::------------------------------------------------------------------------------
:: NetInfo - based on http://www.dostips.com/forum/viewtopic.php?f=3&t=7893
::------------------------------------------------------------------------------
@echo off
setlocal enabledelayedexpansion

:: Toggle marker initialization
for /l %%A in (1,1,6) do set "toggle[%%A]= "

:: Toggle settings initialization
set "ping_address="
set "tracert_address="

:: Store the actions in an array for easier processing later
set "action[1]=ipconfig"
set "action[2]=netstat"
set "action[3]=net view"
set "action[4]=ping !ping_address!"
set "action[5]=tracert !tracert_address!"

:: Displays usage text
if "%~1"=="/?" (
	echo(
	echo(USAGE
	echo(    netinfo.bat
	echo(
	echo(DESCRIPTION
	echo(    netinfo gets a collection of information about your network
	echo(    and either displays it to the command prompt or outputs it to
	echo(    a text file.
	exit /b
)

:main_menu
title Network Information
cls
for /L %%A in (1,1,5) do (
	echo(%%A. [!toggle[%%A]!] !action[%%A]!
)
echo(6. [!toggle[6]!] Save output to file: !export_file_name!
echo(
echo([B]egin     [Q]uit
choice /C:123456BQ /N >nul

:: Toggle options based on user input
if %errorlevel% LEQ 6 call :toggle_marker %errorlevel%
if "%errorlevel%"=="7" call :begin
if "%errorlevel%"=="8" exit /b
goto :main_menu

::------------------------------------------------------------------------------
:: Toggles the state of the toggle marker
::
:: Arguments: %1 - The index of the toggle array to toggle
:: Returns:   Additional 
::------------------------------------------------------------------------------
:toggle_marker
if "!toggle[%1]!"==" " (set "toggle[%~1]=X") else (set "toggle[%~1]= ")

:: Either set or clear the ping address if %1 is 4
if "%~1"=="4" (
	if "!toggle[4]!"==" " (
		set "ping_address="
	) else (
		set /p "ping_address=Options and address to ping: "
		REM A good script would check that a valid IP address was entered.
		REM A lazy programmer knows that ping throws an error.
		set "action[4]=ping !ping_address!"
	)
)

:: Either set or clear the tracert address if %1 is 5
if "%~1"=="5" (
	if "!toggle[5]!"==" " (
		set "tracert_address="
	) else (
		REM Because of how the command is set up, you can include options here.
		REM `-w 200 -h 10 -4` is highly recommended
		set /p "tracert_address=Options and address to trace: "
		set "action[5]=tracert !tracert_address!"
	)
)

:: Either set or clear the save file if %1 is 6
if "%~1"=="6" (
	if "!toggle[6]!"==" " (
		set "export_file_name="
	) else (
		set /p "export_file_name=Export file name: "
		if "!export_file_name!"=="" set "toggle[6]= "
	)
)
exit /b

::------------------------------------------------------------------------------
:: Loops through the possible acions and executes them if the marker is set
::
:: Arguments: None
:: Returns:   None
::------------------------------------------------------------------------------
:begin
if "!toggle[6]!"=="X" echo(Please wait...

for /L %%A in (1,1,5) do (
	if "!toggle[%%A]!"=="X" (
		if not "!export_file_name!"=="" (
			title Gathering network info - !action[%%A]!
			(
				echo == !action[%%A]! ==
				!action[%%A]!
				echo/
			)>>"!export_file_name!"
		) else (
			cls
			title Gathering network info - !action[%%A]!
			!action[%%A]!
			pause
		)
	)
)
exit /b